
**基于gulp的集成构建方案，支持预定义模板，流程构建、代码发布。适合小团队快速构建发布**

## Install

```shell
npm install -g 37sy-build
```

##说明
- 第一次安装工具，需要运行`fe set <name> [content]` 初始化工具。可以设置的选项有

	+ <__tempDir>： 工具全局缓存，模板、临时文件存放的地方。默认是$home。如果没有在项目目录配置发布路径，默认也会发布到这个目录。
	+ <__git>: 自定义模板以及工具配置的git地址。之所以放在git上，是为了能动态维护模板，更新配置。

- 拉取模板及配置。运行`fe -u`，即可拉取模板。第一次工具会clone项目下来，之后会update获取更新。所以需要在git上建立项目，存放模板。

- 初始化项目配置：
	+ `fe -i` 生成项目目录及项目配置文件（指令选项见工具配置说明）

- 开发命令:
	+ `fe` 本地实时刷新
	+ `fe dev` 发布至测试服务器（ftp）
	+ `fe pro` 发布至生产服务器（ftp） 

- git自定义模板及配置目录结构：

   - project <br>
     |
     --template<br>
     |
     --fe-config.js


- 工具配置
	- 工具配置文件名为`fe-config.js`,
 

- 工具模板


## Commands

- `fe help`：查看帮助
- `fe -u`： 从git上拉取预定义的模板 
- `fe -i`： 在当前目录初始化模板目录，生成项目配置


- `fe set <name> [path]`：工具设置
    * `fe set __tempdir ...：` 设置工具缓存目录（模板文件、构建缓存）
    * `fe set __git ... ：` 设置模板git地址


- `fe dev`： 构建并ftp发布至测试服环境
    - `fe dev -l`： 监控文件变动，实时构建并ftp发布至测试服环境


- `fe pro`： 构建并ftp发布至生产环境
    - `fe pro -l`： 监控文件变动，实时构建并ftp发布至生产环境
</br>

- `fe test`: mocha测试










