'use strict';
var fs = require("fs");
var path = require("path")
const URL = "http://code.37ops.com/sy_frontend/build-hot-upate.git";


const execSync = require('child_process').execSync;

var config = null;

var base = {
    checkInit: function () {
        var configPath = base.configPath();

        return fs.existsSync(configPath);
    },
    getBisArr: function () {
        var arr = new Array();
        for (var i in config.bis_tem_ftp) {
            arr.push(i);
        }
        return arr;
    },
    getCnArr: function () {
        var arr = new Array();
        for (var i in config.bis_tem_ftp) {
            arr.push(config.bis_tem_ftp[i].cn);
        }
        return arr;
    },
    getBisBycn:function(cn){
        for (var i in config.bis_tem_ftp){
            if(config.bis_tem_ftp[i].cn == cn){
                return config.bis_tem_ftp[i];
            }
        }
    },
    getFtp: function () {
        
        return config.ftpConfig;
    },
    getBis: function (key) {
        return config.bis_tem_ftp[key];
    },
    getFtpPath: function (key) {
        return config.ftpPath;
    },
    tmpath: function (tem) {
        return __tempDir + "/template/" + tem.name;
    },
    makeFtpPath: function (chooseBis, projectName) {
        return {
            html: chooseBis.html + "/" + chooseBis.uri + "/" + projectName,
            res: chooseBis.res + "/" + chooseBis.uri + "/" + projectName,
        }
    },
    configPath: function () {
        return __tempDir + "/fe-config.js";
    },
    projectConfig: function () {
        return process.cwd() + "/build.json";
    },
    copy:function(path,targetPathName){
            function copy(src,dest){
                try{
                    fs.accessSync(src)
                }catch(e){
                    return;
                }
                var read ,write,srcPath,destPath;
                
                var stat =  fs.statSync(src);
                
                if(stat.isFile()){
                    read = fs.createReadStream(src);
                    write = fs.createWriteStream(dest);
                    read.pipe(write);
                }
                if(stat.isDirectory()){
                    base.makeDirs(dest);
                    var dirs = fs.readdirSync(src);
                    dirs.forEach(function(value,index){
                        srcPath = src +"/"+value;
                        destPath = dest + "/"+value;
                        copy(srcPath,destPath);
                    })
                }
                
            }

            copy(path,targetPathName)
        
    },
    makeDirs:function (dir){ 
        try{
            fs.accessSync(path.dirname(dir));
            try{
                fs.mkdirSync(dir);
            }catch(e){
                
            }
        }catch(e){
            base.makeDirs(path.dirname(dir));
            try{
                fs.accessSync(path.dirname(dir));
                fs.mkdirSync(dir);
            }catch(e){
                 console.error(e)
            }
        }
    },

    hotUpdate:function(call){
		const URL = __git||"http://code.37ops.com/sy_frontend/build-hot-upate.git";

        if(fs.existsSync(__tempDir)){
            console.log(execSync(`git pull`,{cwd:__tempDir}).toString());

        }else{
            console.log(execSync([
                `git clone  ${URL} ${__tempDir}`
            ].join('&&')) + '');
        }

		call&&call();
    },
    init:function(){
        var configPath = base.configPath();
		config = require(configPath);
    }
}

module.exports = base;

