"use strict"
const base = require("./base.js");
const prompt = require('prompt');
const path = require("path");
const fs = require("fs");
const EventEmitter = require('events');

class Event extends EventEmitter {}

const event = new Event();

var ftp = null;

function stdPromt(obj,call){
	prompt.start()
	prompt.get(obj, function (err, result) {
		if(err){
			return;
		}
		call&&call(result);
	})
}

function chooseStdPromt(arr,des,call,err){
	
	var consoleStr = "";
	var rex = "";
	arr.forEach(function(str,index){
		consoleStr += "【"+(index)+"】"+ str+" ";
		rex+=""+(index);
	})
	rex = new RegExp("^["+rex+"]{1}$");
	
	console.log(consoleStr);
	var schema = {
		properties: {
		  data: {
		    pattern: rex,
		    message: err||'指令错误',
		    required: false,
		    description:des
		  }
		}
	};
	stdPromt(schema,function(result){
		var index  = result.data?Number(result.data):0;

		call&&call(arr[index]);
	})
}

//选择业务
function chooseBis(){
	var bisArr = base.getCnArr();
	chooseStdPromt(bisArr,"选择对应的业务类型",function(cn){
		var choiceBis = base.getBisBycn(cn);
		makeJsonByBis(choiceBis);
	})
}

//生成线上发布地址


//生成build.json()

function makeJsonByBis(obj){
	if(obj.html){
		if(obj.res){
			chooseName(obj)
		}else{
			chooseRes(function(res){
				obj.res = res;
				chooseName(obj);
			})
		}
	}else{
		chooseHtml(function(html){
			obj.html = html;

			if(obj.res){
				chooseName(obj);
			}else{
				chooseRes(function(res){
					obj.res = res;
					chooseName(obj);
				})
			}
		})
	}
}


function chooseHtml(call){
	var htmlArr = base.getFtpPath().html;
	chooseStdPromt(htmlArr,"选择对应的业务类型",function(result){
		 call&&call(result);
	})
}



function chooseRes(call){
	var resArr = base.getFtpPath().res;
	chooseStdPromt(resArr,"选择对应的业务类型",function(result){
		 call&&call(result);
	})
}

function chooseName(obj){
	var schema = {};
	schema.properties ={};
	schema.properties.pjName =  {
		pattern: /^[\w\d-_]+$/,
		message: '数字字母下划线',
		required: true,
		description:'输入项目名称',
		before:function(value){
			return value.replace(/-t$/,function(){
				var date = new Date();
				return "-"+date.getFullYear().toString()+date.getMonth().toString()+date.getDate().toString();
			})
		}
	}
	stdPromt(schema,function(result){
		obj.pjName = result.pjName;
		var ftpPathO = base.makeFtpPath(obj,result.pjName);
		obj.res = ftpPathO.res;
		obj.html = ftpPathO.html;
		checkAndMakeJson(obj);
	})
}

//检测远程目录是否存在
function checkAndMakeJson(result){
	//资源路径是否存在
	ftp.list(result.res,function(err,arr){
		
		if(typeof arr == "undefined"){
			//html路径是否存在
			ftp.list(result.html,function(err,arrA){
				if(typeof arrA == "undefined"){
					//都不存在情况，开始写入本地目录
					writeBuildJson(result);
				}else{

					fileExsitHandle(result);
				}
			})
			
		}else{	
		
			fileExsitHandle(result);
		}
		
		ftp.end();
	})
}

//写入目录
function writeBuildJson(data){
	var json = {};
/*	var pjPath = path.resolve(data.pjName);

	base.makeDirs(pjPath);*/
	var pjPath = process.cwd();

	if(data.tem){
		console.log(path.resolve(base.tmpath(data.tem)+"/**/*"),pjPath)
		base.copy(path.resolve(base.tmpath(data.tem)+"/"),pjPath,function(err, files){
			if (err) throw err;
			console.log(err)
		});
		json.specify = data.tem.specify;
	}

	var ws = fs.createWriteStream(pjPath+"/build.json");

	json.html=data.html;
	json.res=data.res;

	ws.write(JSON.stringify(json,null,1));
	ws.end();
	console.log("生成成功");
}

//远程文件不存在处理
function fileExsitHandle(data){

	prompt.delimiter = ": ";
	prompt.message="";
	var schema = {
		properties: {
		  answer: {
		    pattern: /^[\w]$/,
		    message: '指令错误',
		    required: true,
		    description:'远程线上目录已存在,是否继续?（Y/N）'
		  }
		}
	};

	prompt.start();
	prompt.get(schema, function (err, result) {
		if(err){
			return;
		}

		if(result.answer.search(/[Y/y]/)>-1){
			console.log("\r\n正在生成build.json文件...\r\n");
			
			writeBuildJson(data)
		}
		if(result.answer.search(/[N/n]/)>-1){
			console.log("\r\n未生成build.json文件\r\n");
			process.exit(0)
		}
	})

}

//递归创建目录

module.exports={
	start:function(f){
		ftp = f;
		chooseBis();
	}
}